#define LIST_C TRUE
/* ========================================================================
 * Name - list.c
 *
 * Description - 
 *   Generic functions for lists with 3 char * elements. 
 *   Basic things, all of which seemed a good idea at the time.
 *
 * $Id: list.c,v 1.2 1992/09/15 22:37:12 penneyj Exp $
 *
 * $Log: list.c,v $
 * Revision 1.2  1992/09/15  22:37:12  penneyj
 * misc facelift, preparing for distribution on alt.sources
 *
 * Revision 1.1  1992/09/15  22:18:47  penneyj
 * Initial revision
 *
 *========================================================================
 */

#include "general.h"
#include "config.h"
#include "utils.h"

#include "list.h" /* this file's interface */

#if defined(FLG_PROTOTYPE)
ListType newlist(void)
#else
ListType newlist()
#endif
{
  ListType liststart = (ListType)MyMalloc(sizeof(liststart));

  *liststart = NULL;
  return liststart;
}

#if defined(FLG_PROTOTYPE)
ListType addnull(ListType argl)
#else
ListType addnull(argl)
     ListType argl;
#endif
{
  while (*argl != NULL)
    argl = &(*argl)->next;
  *argl = (NodeSType *)MyMalloc(sizeof(NodeSType));
  (*argl)->key = (*argl)->catname = (*argl)->dirname = NULL;
  (*argl)->next = NULL;
  return argl;
}


#if defined(FLG_PROTOTYPE)
int inlist23(ListType argl, const char *item2, const char *item3)
#else
int inlist23(argl,item2,item3)
     ListType argl;
     const char *item2, *item3;
#endif
{
  while (*argl != NULL) {
    if ((*argl)->catname == item2 && (*argl)->dirname == item3)
      return TRUE;
    argl = &(*argl)->next;
    }
  return FALSE;
}


#if defined(FLG_PROTOTYPE)
void add3list(ListType argl, const char *item1, const char *item2,
    const char *item3, manPageEType kind)
#else
void add3list(argl,item1,item2,item3, kind)
     ListType argl;
     const char *item1, *item2, *item3;
     manPageEType kind;
#endif
{
  while (*argl != NULL)
    argl = &(*argl)->next;
  *argl = (NodeSType *)MyMalloc(sizeof(NodeSType));
  (*argl)->key = (char *)item1;
  (*argl)->catname = (char *)item2;
  (*argl)->dirname = (char *)item3;
  (*argl)->next = NULL;
  (*argl)->kind = kind;
}

#if defined(FLG_PROTOTYPE)
void push3list(ListType argl, const char *item1, const char *item2,
    const char *item3)
#else
void push3list(argl,item1,item2,item3)
     ListType argl;
     const char *item1, *item2, *item3;
#endif
{
  NodeSType *pointer = *argl;

  *argl = (NodeSType *)MyMalloc(sizeof(NodeSType));
  (*argl)->key = (char *)item1;
  (*argl)->catname = (char *)item2;
  (*argl)->dirname = (char *)item3;
  (*argl)->next = pointer;
}

#if defined(FLG_PROTOTYPE)
void cleannulls(ListType argl)
#else
void cleannulls(argl)
     ListType argl;
#endif
{
  for (; *argl != NULL; argl = &(*argl)->next)
    while ((*argl)->key == NULL && (*argl)->catname == NULL &&
        (*argl)->dirname == NULL) {
      *argl = (*argl)->next;
      if (*argl == NULL)
	return;
      }
}

#if defined(FLG_PROTOTYPE)
void printlist(ListType argl)
#else
void printlist(argl)
     ListType argl;
#endif
{
  ListType item;
  
  LIST_DO(argl) {
    printf("-%s-%s-%s-\n",
	(*item)->key ? (*item)->key : "(null)",
	(*item)->catname ? (*item)->catname : "(null)",
	(*item)->dirname ? (*item)->dirname: "(null)");
    }
}

#if defined(FLG_PROTOTYPE)
int noofitems(ListType argl)
#else
int noofitems(argl)
     ListType argl;
#endif
{
  ListType item;
  int counter = 0;
  
  LIST_DO(argl) {
    counter++;
    }
  return counter;
}
